SystemOrganization addCategory: #'PharoBot-Core'!

Object subclass: #PharoBotEnvironmentWithObjects
	instanceVariableNames: 'workspaces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotEnvironmentWithObjects commentStamp: 'NahuelGarbezza 2/10/2012 14:54' prior: 0!
I am responsible for holding the environment classes (Robot and user-defined), and for import/export them.!

PharoBotEnvironmentWithObjects subclass: #PharoBotEnvironmentWithClasses
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
addClass: aClass

	self classes add: aClass! !

!PharoBotEnvironmentWithClasses methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/27/2012 11:12'!
classes

	^classes! !

!PharoBotEnvironmentWithClasses methodsFor: 'constants' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
defaultVariableBindings

	^{}! !

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
exportClassTo: aFileName
	
	self shouldBeImplemented.! !

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
importClassFrom: aFileName
	
	self shouldBeImplemented.
	"Llamar a addClass:"! !

!PharoBotEnvironmentWithClasses methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 2/27/2012 11:13'!
initialize

	super initialize.
	classes := OrderedCollection with: self robotClass! !

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
removeClass: aClass

	self classes remove: aClass! !

!PharoBotEnvironmentWithClasses methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/27/2012 11:14'!
startWorkspace

	^PharoBotWorkspace new
		title: 'Bienvenido a PharoBot - Clase 2';
		content:'"Bienvenido a PharoBot - Clase 2"';
		variableBindings: self defaultVariableBindings asDictionary;
		yourself! !

!PharoBotEnvironmentWithObjects methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:10'!
addWorkspace: aWorkspace

	self workspaces add: aWorkspace! !

!PharoBotEnvironmentWithObjects methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/27/2012 11:11'!
defaultVariableBindings

	"Reemplazar, cuando este la clase Robot"
	^{ #robotech -> 'self robotClass new' }! !

!PharoBotEnvironmentWithObjects methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 2/27/2012 11:09'!
initialize

	workspaces := OrderedCollection with: self startWorkspace.! !

!PharoBotEnvironmentWithObjects methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:10'!
removeWorkspace: aWorkspace

	self workspaces remove: aWorkspace! !

!PharoBotEnvironmentWithObjects methodsFor: 'constants' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
robotClass

	"TODO cuando este la clase Robot, reemplazar String por Robot"
	^String! !

!PharoBotEnvironmentWithObjects methodsFor: 'constants' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
robotMethods

	"Reemplazar por los metodos de la clase Robot que se quieran mostrar"
	^self robotClass selectors! !

!PharoBotEnvironmentWithObjects methodsFor: 'constants' stamp: 'NahuelGarbezza 2/27/2012 11:14'!
startWorkspace

	^PharoBotWorkspace new
		title: 'Bienvenido a PharoBot - Clase 1';
		content:
'
"Bienvenido a PharoBot - Clase 1"

robotech mover: 100.
robotech norte.

etc, etc, etc...
';
	variableBindings: self defaultVariableBindings asDictionary;
	yourself! !

!PharoBotEnvironmentWithObjects methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/27/2012 11:09'!
workspaces

	^workspaces! !

Object subclass: #PharoBotWorkspace
	instanceVariableNames: 'title content variableBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/11/2012 17:02'!
content
	^ content! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/11/2012 17:02'!
content: anObject
	content := anObject! !

!PharoBotWorkspace methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 2/11/2012 17:08'!
initialize

	variableBindings := Dictionary new.! !

!PharoBotWorkspace methodsFor: 'printing' stamp: 'NahuelGarbezza 2/11/2012 17:04'!
printOn: aStream

	aStream << self title! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/11/2012 17:02'!
title
	^ title! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/11/2012 17:02'!
title: anObject
	title := anObject! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/11/2012 17:07'!
variableBindings
	^ variableBindings! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/11/2012 17:07'!
variableBindings: anObject
	variableBindings := anObject! !
